----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    16:05:26 08/18/2010 
-- Design Name: 
-- Module Name:    Fifo16Bit_to_8_Bit - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;


-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity Preparation_for_Fifo_16Bit_to_8_Bit is

Port (	CLK_100MHZ 						: in std_logic;
			SPRAM_ADDRESS_FIFO_CYLCE	: out std_logic_VECTOR(12 downto 0); 
			FIFO_ENABLE						: in std_logic;
			DATA_FROM_SPRAM		   	: in std_logic_VECTOR(24 downto 0);
			--FIFO_DATA_OUT					: out std_logic_VECTOR (15 downto 0);
			FIFO_WRITE_ENABLE_OUT		: out std_logic;
			FIFO_DATA_IN					: out std_logic_vector (15 downto 0);
			RESET								: in std_logic
			);
		



end  Preparation_for_Fifo_16Bit_to_8_Bit;

architecture Behavioral of Preparation_for_Fifo_16Bit_to_8_Bit is

--component Fifo
--	port (
--	rst: IN std_logic;
--	wr_clk: IN std_logic;
--	rd_clk: IN std_logic;
--	din: IN std_logic_VECTOR(15 downto 0);
--	wr_en: IN std_logic;
--	rd_en: IN std_logic;
--	dout: OUT std_logic_VECTOR(15 downto 0);
--	full: OUT std_logic;
--	empty: OUT std_logic);
--end component;



Signal FIFO_RESET 						: std_logic:='0';

Signal FIFO_WRITE_ENABLE				: std_logic;
--Signal FIFO_DATA_IN						: std_logic_vector (15 downto 0);	
--Signal FIFO_DATA_OUT						: std_logic_VECTOR(15 downto 0);
--Signal FIFO_FULL							: std_logic;
--Signal FIFO_EMPTY							: std_logic;
Signal SPRAM_WRITE_TO_FIFO_ADRESS	: std_logic_vector (12 downto 0);
Signal WRITE_ENABLE						: std_logic;
--signal FIFO_WRITE_ENABLE_OUT_1 		: std_logic;

type FSM_FIFO_WRITE			is 	(TRACKING, WRITE_FIFO,WAIT_STATE);
Signal CURRENT_STATE						: FSM_FIFO_WRITE:= TRACKING;
Signal NEXT_STATE							: FSM_FIFO_WRITE;
Signal JUMP_NEXT_STATE_ENABLE 		: std_logic;
				
begin

	SPRAM_ADDRESS_FIFO_CYLCE <= (others => '0') when RESET = '1' else
										 SPRAM_WRITE_TO_FIFO_ADRESS;
	
	
	FIFO_WRITE_ENABLE_OUT    <= '0' when RESET = '1' else
										 FIFO_WRITE_ENABLE;
	
	--FIFO_WRITE_ENABLE_OUT_1 <= FIFO_WRITE_ENABLE;
	
-- Erzeugen der Synchronisation des FIFOs
	--FIFO_DATA_IN <= DATA_FROM_SPRAM(24 downto 9) when FIFO_WRITE_ENABLE = '1'; 
					--	 x"7E7E" when SPRAM_WRITE_TO_FIFO_ADRESS = "0000000000001" else
					--	 x"7E7E" when SPRAM_WRITE_TO_FIFO_ADRESS = "0000000000011" else
					--	 DATA_FROM_SPRAM(24 downto 9);
					
						 
						 
						 
						 --x"7E7E" when SPRAM_WRITE_TO_FIFO_ADRESS = "0000000000001";
	
	
---------------------------------------------------------------------------------------------
--  DIESE STATEMACHINE IST FR DAS ERZEUGEN DES FIFO WRITE ENABLES SIGNALS ZUSTNDIG, DIESER AUTOMAT
-- WIRD GLEICHERMA?EN VON DER LETZEN KURVE GETRIGGERT
---------------------------------------------------------------------------------------------

	SWITCH_STATE: process (CLK_100MHZ, SPRAM_WRITE_TO_FIFO_ADRESS)
	begin
	
	--if SPRAM_WRITE_TO_FIFO_ADRESS = "0000000000000" then  -- asynchrone Zuweisung
	--	FIFO_DATA_IN <= x"7E7E";
		--	elsif SPRAM_WRITE_TO_FIFO_ADRESS = "0000000000001" then
					--FIFO_DATA_IN <= x"7E7E";
	--else
	
		if rising_edge (CLK_100MHZ) then
			CURRENT_STATE <= NEXT_STATE;
		--	if SPRAM_WRITE_TO_FIFO_ADRESS = "0000000000000" then
		--		FIFO_DATA_IN <= x"7E7E";
			--		elsif SPRAM_WRITE_TO_FIFO_ADRESS = "0000000000001" then
			--		FIFO_DATA_IN <= x"7E7E";
		--	else	
				FIFO_DATA_IN <= DATA_FROM_SPRAM(24 downto 9);
		--	end if;
		end if;
	-- end if;
	end process SWITCH_STATE;


	
	
	FIFO_FSM_PROCEDURE: Process (CURRENT_STATE,FIFO_ENABLE,JUMP_NEXT_STATE_ENABLE)
	Begin
	
	case CURRENT_STATE is
	
	when TRACKING		=>						WRITE_ENABLE  <= '0';
													if FIFO_ENABLE = '1' then
										
														NEXT_STATE <= WRITE_FIFO;
													else
														NEXT_STATE <= TRACKING;
													end if;
													
	--when perpar_FOR_WRITE =>				WRITE_ENABLE  <= '1';
										--			if FIFO_ENABLE = '1' then
											--			WRITE_ENABLE  <= '1';
											--			NEXT_STATE <= WRITE_FIFO;
											--		else
											--		NEXT_STATE <= TRACKING;
											--		end if;
	
	
	
	
	when WRITE_FIFO	=>						WRITE_ENABLE  <= '1';
													if JUMP_NEXT_STATE_ENABLE = '1' then
														NEXT_STATE <= WAIT_STATE;
													else
														NEXT_STATE <= WRITE_FIFO;
													end if;
													
	when WAIT_STATE	=>						WRITE_ENABLE  <= '0';
													if FIFO_ENABLE = '1' then
														NEXT_STATE <= WAIT_STATE;
													else
														NEXT_STATE <= TRACKING;
													end if;

	end case;
	end process FIFO_FSM_PROCEDURE;

	
	
	
	-- DIESER PROZESS BESTIMMT ZUM EINEM DAS FIFO WRITE ENABLE ZUM ANDEREN ERZEUGT ES DEN ADRESS ZYKLUS DES SPRAMS WENN DIE DATEN VOM SPRAM INS FIFO GESCHRIEBEN WERDEN SOLLEN
	BRAM_TO_FIFO: Process (CLK_100MHz,RESET)
	Begin
		if RESET = '1' then
			JUMP_NEXT_STATE_ENABLE 		<= '0';
			SPRAM_WRITE_TO_FIFO_ADRESS <= (others => '0');
			FIFO_WRITE_ENABLE 			<= '0';
			else
		if falling_edge (CLK_100MHZ) then
			if WRITE_ENABLE = '1' then
				if SPRAM_WRITE_TO_FIFO_ADRESS >= "1110000011111" then --"1110000011111"
					SPRAM_WRITE_TO_FIFO_ADRESS <= SPRAM_WRITE_TO_FIFO_ADRESS;
					FIFO_WRITE_ENABLE 			<= '0';
					JUMP_NEXT_STATE_ENABLE <= '1';--'0';
			--	elsif SPRAM_WRITE_TO_FIFO_ADRESS = "0000000000000" then
					--JUMP_NEXT_STATE_ENABLE <= '0';--'1';
					--FIFO_WRITE_ENABLE		  <= '1';
				else	
					JUMP_NEXT_STATE_ENABLE <= '0';--'1';
					FIFO_WRITE_ENABLE		  <= '1';	
					SPRAM_WRITE_TO_FIFO_ADRESS <= SPRAM_WRITE_TO_FIFO_ADRESS + 1; 
				end if;
			else
				JUMP_NEXT_STATE_ENABLE 		<= '0';
				FIFO_WRITE_ENABLE 			<= '0';
				SPRAM_WRITE_TO_FIFO_ADRESS <= "0000000000000";
			end if;
		end if;
		end if;
	End Process BRAM_TO_FIFO;





--Component1  : Fifo
--		port map (
--			rst => FIFO_RESET,
--			wr_clk => CLK_100MHZ,
--			rd_clk => CLK_100MHZ,
--			din 	=> FIFO_DATA_IN,
--			wr_en => FIFO_WRITE_ENABLE,
--			rd_en => '1',--'0',
--			dout => FIFO_DATA_OUT,
--			full => FIFO_FULL,
--			empty => FIFO_EMPTY);

end Behavioral;

